/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 31/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.TypePegawai;
import com.portofolio.entity.vo.TypePegawaiId;

import org.springframework.context.annotation.Lazy;

@Lazy
@Repository
public interface TypePegawaiDao extends CrudRepository<TypePegawai, TypePegawaiId> {

	@Query(QListAll)
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("statusEnabled") boolean statusEnabled, Pageable page);

	@Query(QListAll + " and model.namaTypePegawai like %:namaTypePegawai% ")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("namaTypePegawai") String namaTypePegawai, @Param("statusEnabled") boolean statusEnabled,Pageable page);

	@Query(QListAll + " and model.id.kdTypePegawai = :kdTypePegawai")
	Map<String, Object> findByKdTypePegawai(@Param("kdProfile") Integer kdProfile,@Param("kdTypePegawai") Integer kdTypePegawai, @Param("statusEnabled") boolean statusEnabled);

    
    String QListAll ="select new map(model.id.kdTypePegawai as kdTypePegawai,model.id.kdProfile as kdProfile "
            + ", model.namaTypePegawai as namaTypePegawai " 
            + ", model.reportDisplay as reportDisplay " 
            + ", model.kodeExternal as kodeExternal " 
            + ", model.namaExternal as namaExternal " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec " 
            + ", model.version as version )" 
            + " from TypePegawai model "
            + "left join model.id id left join model.profile profile where model.id.kdProfile =:kdProfile and model.statusEnabled = :statusEnabled "; 

}
